//
//  WRHAlertView.m
//  22221
//
//  Created by cheyoo on 2016/11/15.
//  Copyright © 2016年 cheyoo. All rights reserved.
//

#import "WRHAlertView.h"
#import <UIKit/UIKit.h>
#import "UIView+Extension.h"
#define WRHScreenW  [UIScreen mainScreen].bounds.size.width
#define WRHScrwwnH  [UIScreen mainScreen].bounds.size.height
#define WRHColorRGBA(r,g,b,a) [UIColor colorWithRed:(r/255.0) green:(g/255.0) blue:(b/255.0) alpha:a]
#define WRHColor(r,g,b) WRHColorRGBA(r,g,b,1.0)
#define WRHColorFromRGB(value)  [UIColor colorWithRed:(((value&0xFF0000)>>16)/255.0) green:(((value&0x00FF00)>>8)/255.0) blue:(((value&0x0000FF)>>0)/255.0) alpha:1.0]
#define UPMargin 20
#define midMargin 10
#define ButtonMargin 10
static WRHAlertView* wrhAlertView;
@interface WRHAlertView()
@property(nonatomic,strong)UIView* cover;//背景覆盖
@property(nonatomic,strong)UIView* baseView;//白色的底部view
@property(nonatomic,strong)UILabel* titleLabel;//标题label
//@property(nonatomic,strong)UILabel* messageLabel;
@property(nonatomic,strong)NSMutableArray *buttonArr;//按钮数组
@property(nonatomic,strong)NSMutableArray *messageArr;//消息label数组
@property(nonatomic,assign)CGFloat titleH;//标题长度；
@property(nonatomic,assign)CGFloat messageH;//消息模块长度
@property(nonatomic,assign)CGFloat buttonH;//按钮模块长度
@property(nonatomic,strong)UIActivityIndicatorView* activityIndicator;
@property(nonatomic,strong)UIColor* titileColor;
@property(nonatomic,strong)UIFont* titileFont;
@property(nonatomic,strong)NSMutableArray<UIColor*>* messageColors;
@property(nonatomic,strong)NSMutableArray<UIFont*>* messageFont;
@property(nonatomic,strong)NSMutableArray<UIColor*>* buttonColors;
@property(nonatomic,strong)NSMutableArray<UIFont*>* buttonFont;

@end
@implementation WRHAlertView
- (instancetype)init
{
    self = [super init];
    if (self) {
        if (!wrhAlertView) {
            wrhAlertView=self;
        }
        _buttonFont=[[NSMutableArray alloc]initWithCapacity:10];
        _buttonColors=[[NSMutableArray alloc]initWithCapacity:10];
        _messageFont=[[NSMutableArray alloc]initWithCapacity:10];
        _messageColors=[[NSMutableArray alloc]initWithCapacity:10];
        

    }
    return wrhAlertView;
}
-(void)CoverHide{
    self.cover.hidden=YES;
    self.baseView.hidden =YES;
}

-(NSMutableArray*)buttonArr{
    if (_buttonArr==nil) {
        _buttonArr=[[NSMutableArray alloc]init];
    }
    return _buttonArr;
}
-(NSMutableArray*)messageArr{
    if (_messageArr==nil) {
        _messageArr=[[NSMutableArray alloc]init];
    }
    return _messageArr;
}
-(void)setTitleColor:(UIColor*)titileColor AndTitleFont:(UIFont*)TitleFont{
    self.titileFont=TitleFont;
    self.titileColor=_titileColor;
    [self setTitleLabelWithTitle:self.title];
    [self setMessagesLabelWithMeassages:self.messages];
    [self setButtonsWithButtonTitle:self.buttonTitles];
    
}
-(void)setMesageColor:(NSArray<UIColor*>*)messageColors AndMesageFont:(NSArray<UIFont*>*)messageFonts{
    NSUInteger min1 =MIN(self.messages.count, messageFonts.count);
    for (int i=0; i<min1; i++) {
        [self.messageFont replaceObjectAtIndex:i withObject:messageFonts[i]];
    }
     NSUInteger min2 =MIN(self.messages.count, messageColors.count);
    for (int i=0; i<min2; i++) {

        [self.messageColors replaceObjectAtIndex:i withObject:messageColors[i]];
    }
    [self setMessagesLabelWithMeassages:self.messages];
    [self setButtonsWithButtonTitle:self.buttonTitles];
}
-(void)setButtonColor:(NSArray<UIColor*>*)buttonColors AndButtonFont:(NSArray<UIFont*>*)buttonFonts{
    NSUInteger min1 =MIN(self.buttonTitles.count, buttonColors.count);

    for (int i=0; i<min1; i++) {
        [self.buttonColors replaceObjectAtIndex:i withObject:buttonColors[i]];
           }
     NSUInteger min2 =MIN(self.buttonTitles.count, buttonFonts.count);
    for (int i=0; i<min2; i++) {
    
        [self.buttonFont replaceObjectAtIndex:i withObject:buttonFonts[i]];
    }
    [self setButtonsWithButtonTitle:self.buttonTitles];
}
//-(void)setTitleColor:(UIColor*)titileColor{
//    self.titileColor=titileColor;
//}
//-(void)setMesageColor:(NSArray<UIColor*>*)messageColors;
//-(void)setButtonColor:(NSArray<UIColor*>*)buttonColors;
//-(void)setTitleFont:(NSFont*)titleFont;
//-(void)setMesageFont:(NSArray<NSFont*>*)messageFonts;
//-(void)setButtonFont:(NSArray<NSFont*>*)buttonFonts;
-(void)activityIndicatorShow{
    if (self.activityIndicator==nil) {
            self.activityIndicator = [[UIActivityIndicatorView alloc] init];
    }
    self.activityIndicator.frame=CGRectMake(100, self.titleH+self.messageH+5, 60, 60);
   [self.baseView addSubview:self.activityIndicator];
    self.activityIndicator.centerX=self.baseView.width*0.5;
   // self.activityIndicator.activityIndicatorViewStyle=UIActivityIndicatorViewStyleGray;
 self.activityIndicator.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
    self.activityIndicator.color=[UIColor blackColor];
    [self.activityIndicator startAnimating];
    self.messageH=self.messageH+60;
    [self setButtonsWithButtonTitle:self.buttonTitles];
}
+(void)useDefualTitlesAndColors{
    [wrhAlertView useDefualTitlesAndColors];
}
-(void)useDefualTitlesAndColors{
    self.titileColor=nil;
    self.titileFont=nil;
    [self.messageColors removeAllObjects];
    [self.messageFont removeAllObjects];
    [self.buttonFont removeAllObjects];
    [self.buttonColors removeAllObjects];
}
+(void)showHUDMessage:(NSString*)message{
    [self alertViewWithTitle:nil messages:@[message] ButtonsWithTitle:nil];
    [wrhAlertView activityIndicatorShow];
}
-(void)setTitle:(NSString*)title messages:(NSArray<NSString*>*)messages ButtonsWithTitle:(NSArray<NSString*>*)buttonTitles{
    if (self.activityIndicator!=nil) {
        [self.activityIndicator stopAnimating];
        [self.activityIndicator removeFromSuperview];
    }

    self.messages=messages;
    self.buttonTitles=buttonTitles;
    self.title=title;
    for (int i=0; i<buttonTitles.count; i++) {
        //NSLog(@"buttonTitles=%@   ",buttonTitles[i]);
    }
    [self defualtColorAndFont];
    [self setTitleLabelWithTitle:title];
    [self setMessagesLabelWithMeassages:messages];
    [self setButtonsWithButtonTitle:buttonTitles];
    self.cover.hidden=NO;
 self.baseView.hidden=NO;
    
}
-(void)defualtColorAndFont{
    if (!_titileColor) {
            _titileColor=WRHColorFromRGB(0xFF7426);//默认颜色
    }
    if (!_titileFont) {
           _titileFont=[UIFont systemFontOfSize:25];//
    }

    
    for (int i=(int)_messageColors.count; i<self.messages.count; i++) {//_messageColors.count和_messageFont。count一致
//        if (!_messageColors[i]) {
//                   _messageColors[i]=[UIColor blackColor];
//        }
//        if (!_messageFont[i]) {
//              _messageFont[i]=[UIFont systemFontOfSize:20];
//        }
        [_messageColors addObject:[UIColor blackColor]];
        [_messageFont addObject:[UIFont systemFontOfSize:20]];
    }
    for (int i =(int)_buttonColors.count; i<self.buttonTitles.count; i++) {
//        if (!_buttonFont[i]) {
//            _buttonFont[i]=[UIFont systemFontOfSize:20];
//        }
//        if (!_buttonColors[i]) {
//        _buttonColors[i]=WRHColorFromRGB(0x0079ff);
//        }
        [_buttonColors addObject:WRHColorFromRGB(0x0079ff)];
        [_buttonFont addObject:[UIFont systemFontOfSize:20]];
        
    }
}
-(void)setTitleLabelWithTitle:(NSString*)title{
    
   self.titleH=UPMargin-midMargin;
    self.titleLabel.text=nil;
//    if ( self.titleLabel!=nil) {
//        [self.titleLabel removeFromSuperview];
//            self.titleLabel=nil;
//    }
    if (title!=nil) {
        self.titleH=40+UPMargin;

        if (self.titleLabel==nil) {
            self.titleLabel=[[UILabel alloc]init];
        }
        self.titleLabel.frame=CGRectMake(0, UPMargin, self.baseView.width, 40);
        [self.baseView addSubview:self.titleLabel];
        self.titleLabel.numberOfLines=0;
        self.titleLabel.textColor=self.titileColor;
        self.titleLabel.font=self.titileFont;
        self.titleLabel.textAlignment=NSTextAlignmentCenter;
       // self.titleLabel.backgroundColor=[UIColor redColor];
        //NSLog(@" self.titleLabel.title=%@",title);
        self.titleLabel.text=title;
        CGSize maxSize=CGSizeMake(self.baseView.width-10*2, MAXFLOAT);
        NSDictionary*dict=@{NSFontAttributeName:self.titileFont};
        CGSize messagesize = [title boundingRectWithSize:maxSize options:NSStringDrawingUsesLineFragmentOrigin attributes:dict context:nil].size;
        self.titleLabel.height=messagesize.height+10;
        self.titleH=self.titleLabel.height+UPMargin;
        
    }else{
        [self.titleLabel removeFromSuperview];
    }
  //NSLog(@"self.titleH=%lf",self.titleH);
}
-(void)setMessagesLabelWithMeassages:(NSArray<NSString*>*)messages{
    //1.清空原有的messagelabel;
    for (UILabel*message in self.messageArr) {
        [message removeFromSuperview];
    }
    [self.messageArr removeAllObjects];
    //4.messageLabel
    self.messageH=0;
    CGFloat messageY=self.titleH+midMargin;
    if (messages!=nil) {
        for (int i=0; i<messages.count; i++) {
            UILabel*messageLabel=[[UILabel alloc]initWithFrame:CGRectMake(0, messageY, self.baseView.width, 25)];
            
            //                self.messageLabel=messageLabel;
            messageLabel.textColor=self.messageColors[i];//WRHColorFromRGB(0xFF7426);
            messageLabel.font=self.messageFont[i];
            messageLabel.textAlignment=NSTextAlignmentCenter;
            messageLabel.numberOfLines=0;
            messageLabel.text=messages[i];
            CGSize maxSize=CGSizeMake(self.baseView.width-10*2, MAXFLOAT);
            NSDictionary*dict=@{NSFontAttributeName:self.messageFont[i]};
            CGSize messagesize = [messages[i] boundingRectWithSize:maxSize options:NSStringDrawingUsesLineFragmentOrigin attributes:dict context:nil].size;
            messageLabel.height=messagesize.height+5;
            self.messageH+=messageLabel.height+midMargin;
            messageY+=(midMargin+messageLabel.height);
            [self.baseView addSubview:messageLabel];
            messageLabel.tag=i;
            [self.messageArr addObject:messageLabel];
            
        }
    }

//  NSLog(@"self.titleH=%lf,self.messageH=%lf",self.titleH,self.messageH);
}
-(void)setButtonsWithButtonTitle:(NSArray<NSString*>*)buttonTitles{
    for (UIButton*but in self.buttonArr) {
        [but removeFromSuperview];
       // but=nil;
    }
    [self.buttonArr removeAllObjects];
    //5.button
   self.buttonH=0;
    CGFloat buttonY=self.titleH+self.messageH+midMargin;
    CGFloat buttonX=0;
    if (buttonTitles!=nil) {
        if (buttonTitles.count==2) {
            for (int i=0; i<buttonTitles.count; i++){
                UIButton*button=[[UIButton alloc]initWithFrame:CGRectMake(buttonX, buttonY, self.baseView.width/2, 50)];
                              //                    button.backgroundColor=[UIColor redColor];
                [button setTitleColor:self.buttonColors[i] forState:UIControlStateNormal];
                [button setFont:self.buttonFont[i]];
                
                [button setTitle:buttonTitles[i] forState:UIControlStateNormal];
                buttonX+=self.baseView.width/buttonTitles.count;
                [button addTarget: self action:@selector(buttonClick:) forControlEvents:UIControlEventTouchUpInside];
                self.buttonH=midMargin+button.height;
                [self.baseView addSubview:button];
                button.tag=i;
                [self.buttonArr addObject:button];
                if (i==1) {
                    UIView*line=[[UIView alloc]initWithFrame:CGRectMake(-button.width,0, self.baseView.width, 1)];
                    line.backgroundColor=[UIColor blackColor];
                    [button addSubview:line];
                    UIView*Vline=[[UIView alloc]initWithFrame:CGRectMake(0, 1, 1, 50-1)];
                    Vline.backgroundColor=[UIColor blackColor];
                    [button addSubview:Vline];

                }
            }
           

        }else{
            for (int i=0; i<buttonTitles.count; i++) {
                UIButton*button=[[UIButton alloc]initWithFrame:CGRectMake(0, buttonY, self.baseView.width, 50)];
                
                UIView*line=[[UIView alloc]initWithFrame:CGRectMake(0, 0, self.baseView.width, 1)];
                line.backgroundColor=[UIColor blackColor];
                [button addSubview:line];
                //WRHColorFromRGB(0x0079ff)
                [button setTitleColor:self.buttonColors[i] forState:UIControlStateNormal];
                [button setFont:self.buttonFont[i]];
                  [button setTitle:buttonTitles[i] forState:UIControlStateNormal];
                buttonX+=self.baseView.width/buttonTitles.count;
                [button addTarget: self action:@selector(buttonClick:) forControlEvents:UIControlEventTouchUpInside];
                self.buttonH+=(midMargin+button.height);
//                NSLog(@"self.buttonFont[i].buttonFontSize=%lf",self.buttonFont[i].systemFontSize);
//                CGSize buttonSize=[self.buttonTitles[i] boundingRectWithSize:CGSizeMake(_baseView.width, CGFLOAT_MAX) options:NSStringDrawingUsesLineFragmentOrigin attributes:@{NSFontAttributeName:self.buttonFont[i]} context:nil].size;
//                button.height=buttonSize.height+10;
                
                buttonY+=(button.height+midMargin);
                button.contentMode=UIViewContentModeCenter;
                [self.baseView addSubview:button];
                button.tag=i;
                [self.buttonArr addObject:button];
            }
            
        }
        
    }
    [self refleshBaseViewHeight];
    //NSLog(@"self.titleH=%lf,self.messageH=%lf,self.buttonH=%lf",self.titleH,self.messageH,self.buttonH);
    }
-(void)refleshBaseViewHeight{
    self.baseView.height=self.titleH+self.messageH+self.buttonH;
    //NSLog(@"baseView.height=%lf",self.baseView.height);
    self.baseView.center=self.cover.center;

}
-(void)buttonClick:(UIButton*)sender{
    
    if (self.activityIndicator!=nil) {
        [self.activityIndicator stopAnimating];
        [self.activityIndicator removeFromSuperview];
    }
        self.cover.hidden=YES;
    self.baseView.hidden=YES;
    if ([self.delegate respondsToSelector:@selector(alertView:didClickButtonAtIndex:)]) {
        [self.delegate alertView:self didClickButtonAtIndex:sender.tag];
    }


}
+(instancetype)alertViewWithTitle:(NSString*)title messages:(NSArray<NSString *>*)messages ButtonsWithTitle:(NSArray<NSString *>*)buttonTitles{
    if (wrhAlertView==nil) {
        wrhAlertView=[[self alloc]init];
    }
    if (wrhAlertView.cover==nil) {
        UIView*cover=[[UIView alloc]initWithFrame:CGRectMake(0, 0, WRHScreenW, WRHScrwwnH)];
        cover.backgroundColor=[UIColor blackColor];//WRHColor(150, 150, 150);
        cover.alpha=0.8;
        [[UIApplication sharedApplication].keyWindow addSubview:cover];
        wrhAlertView.cover=cover;
    }
    if (wrhAlertView.baseView==nil) {
        //2.底部白色的view
        UIView*baseView=[[UIView alloc]initWithFrame:CGRectMake(0, 0, WRHScreenW*0.8, 300)];
        baseView.backgroundColor=[UIColor whiteColor];
        baseView.layer.cornerRadius=10;
        baseView.layer.masksToBounds=YES;
        wrhAlertView.baseView=baseView;
        [[UIApplication sharedApplication].keyWindow addSubview:baseView];
    }
    [wrhAlertView setTitle:title messages:messages ButtonsWithTitle:buttonTitles];

  return  wrhAlertView;
}
+(void)dissmiss{
    [wrhAlertView dissmiss];
   }
-(void)dissmiss{
    [self.cover removeFromSuperview];
    self.cover=nil;
    [self.baseView removeFromSuperview];
    self.baseView=nil;
    
}
-(void)willMoveToSuperview:(UIView *)newSuperview{
    if (self.cover!=nil) {
         [[UIApplication sharedApplication].keyWindow addSubview:self.cover];
    }
   

}
@end
