//
//  WRHAlertView.m
//  22221
//
//  Created by cheyoo on 2016/11/15.
//  Copyright © 2016年 cheyoo. All rights reserved.
//

#import "WRHAlertView.h"
#import <UIKit/UIKit.h>
#import "UIView+Extension.h"
#define WRHScreenW  [UIScreen mainScreen].bounds.size.width
#define WRHScrwwnH  [UIScreen mainScreen].bounds.size.height
#define WRHColorRGBA(r,g,b,a) [UIColor colorWithRed:(r/255.0) green:(g/255.0) blue:(b/255.0) alpha:a]
#define WRHColor(r,g,b) WRHColorRGBA(r,g,b,1.0)
#define WRHColorFromRGB(value)  [UIColor colorWithRed:(((value&0xFF0000)>>16)/255.0) green:(((value&0x00FF00)>>8)/255.0) blue:(((value&0x0000FF)>>0)/255.0) alpha:1.0]
#define UPMargin 20
#define midMargin 10
#define ButtonMargin 10

@interface WRHAlertView()
@property(nonatomic,strong)UIView* cover;//背景覆盖
@property(nonatomic,strong)UIView* baseView;//白色的底部view
@property(nonatomic,strong)UILabel* titleLabel;//标题label
//@property(nonatomic,strong)UILabel* messageLabel;
@property(nonatomic,strong)NSMutableArray *buttonArr;//按钮数组
@property(nonatomic,strong)NSMutableArray *messageArr;//消息label数组
@property(nonatomic,assign)CGFloat titleH;//标题长度；
@property(nonatomic,assign)CGFloat messageH;//消息模块长度
@property(nonatomic,assign)CGFloat buttonH;//按钮模块长度
@property (strong, nonatomic) UIActivityIndicatorView *activityIndicator ;
@end
@implementation WRHAlertView
static WRHAlertView* wrhAlertView;
-(void)CoverHide{
    self.cover.hidden=YES;
    self.baseView.hidden =YES;
}
-(NSMutableArray*)buttonArr{
    if (_buttonArr==nil) {
        _buttonArr=[[NSMutableArray alloc]init];
    }
    return _buttonArr;
}
-(NSMutableArray*)messageArr{
    if (_messageArr==nil) {
        _messageArr=[[NSMutableArray alloc]init];
    }
    return _messageArr;
}
-(void)activityIndicatorShow{
    if (self.activityIndicator==nil) {
            self.activityIndicator = [[UIActivityIndicatorView alloc] initWithFrame:CGRectMake(100, self.titleH+self.messageH+5, 60, 60)];
    }
   [self.baseView addSubview:self.activityIndicator];
    self.activityIndicator.centerX=self.baseView.width*0.5;
    self.activityIndicator.activityIndicatorViewStyle=UIActivityIndicatorViewStyleGray;
 
    [self.activityIndicator startAnimating];
    self.messageH=self.messageH+60;
    [self setButtonsWithButtonTitle:self.buttonTitles];
}
+(void)showHUDMessage:(NSString*)message{
    [self alertViewWithTitle:nil messages:@[message] ButtonsWithTitle:nil];
    [wrhAlertView activityIndicatorShow];
}
-(void)setTitle:(NSString*)title messages:(NSArray<NSString*>*)messages ButtonsWithTitle:(NSArray<NSString*>*)buttonTitles{
    if (self.activityIndicator!=nil) {
        [self.activityIndicator stopAnimating];
        [self.activityIndicator removeFromSuperview];
    }

    self.messages=messages;
    self.buttonTitles=buttonTitles;
    for (int i=0; i<buttonTitles.count; i++) {
        NSLog(@"buttonTitles=%@   ",buttonTitles[i]);
    }
   
    [self setTitleLabelWithTitle:title];
    [self setMessagesLabelWithMeassages:messages];
    [self setButtonsWithButtonTitle:buttonTitles];
    self.cover.hidden=NO;
    self.baseView.hidden=NO;
    
}
-(void)setTitleLabelWithTitle:(NSString*)title{
    
   self.titleH=UPMargin-midMargin;
    self.titleLabel.text=nil;
    //3.titleLabel
    if (title!=nil) {
        self.titleH=40+UPMargin;
        if (self.titleLabel==nil) {
            self.titleLabel=[[UILabel alloc]initWithFrame:CGRectMake(0, UPMargin, self.baseView.width, 40)];
            [self.baseView addSubview:self.titleLabel];
        }
//      UILabel*  titleLabel=self.titleLabel;
        self.titleLabel.numberOfLines=0;
        self.titleLabel.textColor=WRHColorFromRGB(0xFF7426);
        self.titleLabel.font=[UIFont systemFontOfSize:25];
        self.titleLabel.textAlignment=NSTextAlignmentCenter;
        self.titleLabel.text=title;
        CGSize maxSize=CGSizeMake(self.baseView.width-10*2, MAXFLOAT);
        NSDictionary*dict=@{NSFontAttributeName:[UIFont systemFontOfSize:25]};
        CGSize messagesize = [title boundingRectWithSize:maxSize options:NSStringDrawingUsesLineFragmentOrigin attributes:dict context:nil].size;
        self.titleLabel.height=messagesize.height+10;
        self.titleH=self.titleLabel.height+UPMargin;
        
    }
  NSLog(@"self.titleH=%lf",self.titleH);
}
-(void)setMessagesLabelWithMeassages:(NSArray<NSString*>*)messages{
    //1.清空原有的messagelabel;
    for (UILabel*message in self.messageArr) {
        [message removeFromSuperview];
    }
    [self.messageArr removeAllObjects];
    //4.messageLabel
    self.messageH=0;
    CGFloat messageY=self.titleH+midMargin;
    if (messages!=nil) {
        for (int i=0; i<messages.count; i++) {
            UILabel*messageLabel=[[UILabel alloc]initWithFrame:CGRectMake(0, messageY, self.baseView.width, 25)];
            
            //                self.messageLabel=messageLabel;
            messageLabel.textColor=[UIColor blackColor];//WRHColorFromRGB(0xFF7426);
            messageLabel.font=[UIFont systemFontOfSize:20];
            messageLabel.textAlignment=NSTextAlignmentCenter;
            messageLabel.numberOfLines=0;
            messageLabel.text=messages[i];
            CGSize maxSize=CGSizeMake(self.baseView.width-10*2, MAXFLOAT);
            NSDictionary*dict=@{NSFontAttributeName:[UIFont systemFontOfSize:20]};
            CGSize messagesize = [messages[i] boundingRectWithSize:maxSize options:NSStringDrawingUsesLineFragmentOrigin attributes:dict context:nil].size;
            messageLabel.height=messagesize.height+5;
            self.messageH=(messageLabel.height+midMargin)*(i+1);
            messageY+=(midMargin+messageLabel.height);
            [self.baseView addSubview:messageLabel];
            messageLabel.tag=i;
            [self.messageArr addObject:messageLabel];
            
        }
    }
  NSLog(@"self.titleH=%lf,self.messageH=%lf",self.titleH,self.messageH);
}
-(void)setButtonsWithButtonTitle:(NSArray<NSString*>*)buttonTitles{
    for (UIButton*but in self.buttonArr) {
        [but removeFromSuperview];
       // but=nil;
    }
    [self.buttonArr removeAllObjects];
    //5.button
   self.buttonH=0;
    CGFloat buttonY=self.titleH+self.messageH+midMargin;
    CGFloat buttonX=0;
    if (buttonTitles!=nil) {
        if (buttonTitles.count==2) {
            for (int i=0; i<buttonTitles.count; i++){
                UIButton*button=[[UIButton alloc]initWithFrame:CGRectMake(buttonX, buttonY, self.baseView.width/2, 50)];
                              //                    button.backgroundColor=[UIColor redColor];
                [button setTitleColor:WRHColorFromRGB(0x0079ff) forState:UIControlStateNormal];
                [button setFont:[UIFont systemFontOfSize:20]];
                
                [button setTitle:buttonTitles[i] forState:UIControlStateNormal];
                buttonX+=self.baseView.width/buttonTitles.count;
                [button addTarget: self action:@selector(buttonClick:) forControlEvents:UIControlEventTouchUpInside];
                self.buttonH=midMargin+button.height;
                [self.baseView addSubview:button];
                button.tag=i;
                [self.buttonArr addObject:button];
                if (i==1) {
                    UIView*line=[[UIView alloc]initWithFrame:CGRectMake(-button.width,0, self.baseView.width, 1)];
                    line.backgroundColor=[UIColor blackColor];
                    [button addSubview:line];
                    UIView*Vline=[[UIView alloc]initWithFrame:CGRectMake(0, 1, 1, 50-1)];
                    Vline.backgroundColor=[UIColor blackColor];
                    [button addSubview:Vline];

                }
            }
           

        }else{
            for (int i=0; i<buttonTitles.count; i++) {
                UIButton*button=[[UIButton alloc]initWithFrame:CGRectMake(0, buttonY, self.baseView.width, 50)];
                
                UIView*line=[[UIView alloc]initWithFrame:CGRectMake(0, 0, self.baseView.width, 1)];
                line.backgroundColor=[UIColor blackColor];
                [button addSubview:line];
                
                [button setTitleColor:WRHColorFromRGB(0x0079ff) forState:UIControlStateNormal];
                [button setFont:[UIFont systemFontOfSize:20]];
                  [button setTitle:buttonTitles[i] forState:UIControlStateNormal];
                buttonX+=self.baseView.width/buttonTitles.count;
                [button addTarget: self action:@selector(buttonClick:) forControlEvents:UIControlEventTouchUpInside];
                self.buttonH+=(midMargin+button.height);
                buttonY+=(button.height+midMargin);
                [self.baseView addSubview:button];
                button.tag=i;
                [self.buttonArr addObject:button];
            }
            
        }
        
    }
    NSLog(@"self.titleH=%lf,self.messageH=%lf,self.buttonH=%lf",self.titleH,self.messageH,self.buttonH);
    self.baseView.height=self.titleH+self.messageH+self.buttonH;
    NSLog(@"baseView.height=%lf",self.baseView.height);
    self.baseView.center=self.cover.center;
}
-(instancetype)initWithTitle:(NSString*)title messages:(NSArray<NSString *>*)messages ButtonsWithTitle:(NSArray<NSString *>*)buttonTitles{
    if (self=[super init]) {
        _messages=messages;
        _buttonTitles=buttonTitles;
      //1.背景cover
        UIView*cover=[[UIView alloc]initWithFrame:CGRectMake(0, 0, WRHScreenW, WRHScrwwnH)];
        cover.backgroundColor=[UIColor blackColor];//WRHColor(150, 150, 150);
       cover.alpha=0.8;
        
        self.cover=cover;
        cover.hidden=YES;
        [[UIApplication sharedApplication].keyWindow addSubview:cover];
        //2.底部白色的view
        UIView*baseView=[[UIView alloc]initWithFrame:CGRectMake(0, 0, WRHScreenW*0.8, 300)];
        baseView.backgroundColor=[UIColor whiteColor];
        baseView.layer.cornerRadius=10;
        baseView.layer.masksToBounds=YES;
        self.baseView=baseView;
          [[UIApplication sharedApplication].keyWindow addSubview:baseView];
        self.baseView.hidden=YES;
        [self setTitleLabelWithTitle:title];
        [self setMessagesLabelWithMeassages:messages];
        [self setButtonsWithButtonTitle:buttonTitles];
        

        
 
    }
    return self;
}
-(void)buttonClick:(UIButton*)sender{
    
    if (self.activityIndicator!=nil) {
        [self.activityIndicator stopAnimating];
        [self.activityIndicator removeFromSuperview];
    }
        self.cover.hidden=YES;
    self.baseView.hidden=YES;
    if ([self.delegate respondsToSelector:@selector(alertView:didClickButtonAtIndex:)]) {
        [self.delegate alertView:self didClickButtonAtIndex:sender.tag];
    }


}
+(instancetype)alertViewWithTitle:(NSString*)title messages:(NSArray<NSString *>*)messages ButtonsWithTitle:(NSArray<NSString *>*)buttonTitles{
    if (wrhAlertView==nil) {
        wrhAlertView=[[self alloc]init];
    }
  return  [wrhAlertView initWithTitle:title messages:messages ButtonsWithTitle:buttonTitles];
}
+(void)dissmiss{
    [wrhAlertView dissmiss];
   }
-(void)dissmiss{
    [self.cover removeFromSuperview];
    self.cover=nil;
    [self.baseView removeFromSuperview];
    self.baseView=nil;
    
}
-(void)willMoveToSuperview:(UIView *)newSuperview{
    if (self.cover!=nil) {
         [[UIApplication sharedApplication].keyWindow addSubview:self.cover];
    }
   

}
@end
